itk::usual MOS {}

namespace eval mos {

   class GUIDE_STAR {


      constructor { m_c m_i args } { }
      destructor { }
      proc init_guide_star { }

      private method put2 { lll }
      private method ldelete_all { w_list value}
      private method purge_single { j }

      public method get { i ident }
      public method add { }
      public method put { a d }
      public method purge { }
      public method verify { { par_load 0 } }
      public method plot { radius }
      public method reset { }
      public method show { }
      public method guid { }
      public method test { }

      public variable eqx 2000.0
      public variable mos10ali 0

      private variable guid_ra 0.0
      private variable guid_de 0.0
      private variable guid
      private variable num 0;  # NumberOfReferenceTargets
      private variable diff

      private variable m_canvas
      private variable m_image
   }
   # end of the class REF_TARG


#-----------------------------------------------------------------------
   ::itcl::body GUIDE_STAR::constructor { m_c m_i args } {
#-----------------------------------------------------------------------
     # puts stdout "$this: constructor"
     set m_image  $m_i
     set m_canvas $m_c
     set num 0

     for {set i 1} { $i <=10} { incr i 1} {
         set guid($i,a) 0.0
         set guid($i,d) 0.0
         }
     eval configure $args
     }

#-----------------------------------------------------------------------
   ::itcl::body GUIDE_STAR::get { i ident } {

      # ident must be 'a' or 'd' 
      # i must be [1..10]
      if {$i>$num} return
      if {$i<1} return
      return $guid($i,$ident)
   }

#-----------------------------------------------------------------------
   ::itcl::body GUIDE_STAR::add { } {

      set cur $this

      if {$num<3} {
         info_dialog "Add up to [expr 3-$num] guide stars\n\
                  --isolated point source\n\
                  --bright, not saturated\n\
                  --stay inside red contour\n\
                  --\[Enter\] empty string to stop" .skycat1

         set diff 1
         while {$num<10 && $diff} {
              set diff 0
              # puts stdout ">$num< >[$cur get $num a]< \
              #    >[$cur get [expr $num-1] a]< >$diff<"
              EnterObject .eo \
                 -title "Guide Star #[expr $num+1]" \
                 -image .skycat1.image \
                 -labels {ra dec} \
                 -command  [code $cur put2]

              tkwait window .eo
         }
      }
   }

#-----------------------------------------------------------------------
   ::itcl::body GUIDE_STAR::put2 { lll } {

      $this put [lindex $lll 0] [lindex $lll 1]
      $this plot 20
      set diff 1
   }

#-----------------------------------------------------------------------
   ::itcl::body GUIDE_STAR::put { a d } {

      # puts stdout "$this: put $a $d"
      if {$num==10} {
          puts stdout "$this put: Error array full"
      } else {
          set guid([expr $num+1],a) $a
          set guid([expr $num+1],d) $d
          incr num 1
      }
   }

#-----------------------------------------------------------------------
   ::itcl::body GUIDE_STAR::purge { } {

      # j might be a list like 5,1,8
      # 2-4 syntax not provided
      set text "Purge Guide Stars \n\n\ "

      if {$num==0} {
         append text "\nNothing to Purge" 
      } else {
         for {set i 1} {$i <=$num} { incr i 1} {
             append text [format "#%2d   %s   %s\n\ " $i $guid($i,a) $guid($i,d) ]
         }
         append text "\nPress \[Ok\] or Enter e.g. 1,$num\n"
      }

      if {$num==0} {
         info_dialog $text .skycat1
      } else {
         set wid .skycat1.d
         catch {destroy $wid}
         set w [InputDialog $wid \
            -text $text \
            -bitmap warning \
            -modal 1 \
            -buttons {OK Cancel}]

         set loc_list [split [$w activate] , ]

         # we first have to purge the highest order number
         set new_list [lsort -integer -decreasing $loc_list]
         for {set i 0} {$i < [llength $new_list]} { incr i 1 } {
              $this purge_single [lindex $new_list $i]
         }
      }
   }


#-----------------------------------------------------------------------
   ::itcl::body GUIDE_STAR::ldelete_all { w_list value} {

      # modified ldelete
      # delete list elements by value
      set ix [lsearch -exact $w_list $value]
      set new $w_list

      while {$ix>=0} {
            set new [lreplace $w_list $ix $ix]
            set ix [lsearch -exact $new $value]
            set w_list $new
      }
      return $new
   }


#-----------------------------------------------------------------------
   ::itcl::body GUIDE_STAR::verify { { par_load 0 } } {

      # two tests are performed:
      # test1 : if several reference targets are identical
      # test2 : if the reference targets are inside the N3.75-image of the array in the FP
      #
      # For some reason, "find overlapping" works only on filled areas. Therefore, we
      # cannot test directly if the array is inside array image, but we have to verify
      # the the target is outside the forbidden (cyan) zones.
      # 07 12 13: plot_ref_star area is plotted for verify only, area is now filled black

      set text "Verify Positions of \n$num Guide Stars:\n\n"
      set t ""

      if {$num==0} {
         info_dialog "No Guide Star \nVerification Result:\n\n   Failed" .skycat1
         return 1
      }

      for {set i 1} {$i <= $num} { incr i 1} {
          set inside_mask_flag 0; # default outside the focal field
          $m_image convert coords $guid($i,a) $guid($i,d) "wcs $eqx" x y canvas
          set a [$m_canvas find overlapping [expr $x-1] [expr $y-1] [expr $x+1] [expr $y+1] ]
          foreach c $a {
            set local_tags [ldelete_all [split [$m_canvas gettags $c] " "] ""]
            # puts stdout ">$local_tags<"
            if {[string compare [lindex $local_tags 1] gtz]==0} {
               set inside_mask_flag 1
            }
          }
          # this was test2 on the forbidden zone it follows test1 on the dublicate appearance 
          # of reference targets 
          set multi ""
          if {$i<$num} {
             for {set j [expr $i +1] } {$j <= $num} { incr j 1} {
                 $m_image convert coords $guid($i,a) $guid($i,d) "wcs $eqx" lra1 lde1 "deg $eqx"
                 $m_image convert coords $guid($j,a) $guid($j,d) "wcs $eqx" lra2 lde2 "deg $eqx"
                 set t1 [expr $lra1 -$lra2]; set t2 [expr $lde1 -$lde2]
                 # distance in arcsec
                 set t3 [expr sqrt($t1*$t1 + $t2*$t2)*3600.0 ] 
                 if {$t3<2.0} { append multi " = #$j" }
             }
          }
          # test1 finished

          if {$inside_mask_flag} {
             if {$multi != ""} {
                append text " #$i $multi\n"
                if {$t == ""} { append t $i } else { append t ",$i" }
             } else {
                append text " #$i Ok\n" 
             }
          } else {
             append text " #$i Not Accepted\n"
             if {$t == ""} { append t $i } else { append t ",$i" }
          }
      }

      if {$t==""} {
         append text "\nPress \[Ok\]\n"
         info_dialog "Guide Star \nVerification Result:\n\n     Ok" .skycat1
      } else {
         append text "\nEnter $t and \nPress \[Ok\] to purge\n"

         # the rest is the same as in the purge method
         if { $par_load } {
            # verify when loading
            info_dialog "There are guide stars: $t \n In Forbidden Zone!! \n Removing ..." .skycat1
            set loc_list [split $t , ]
            set new_list [lsort -integer -decreasing $loc_list]
            for {set i 0} {$i < [llength $new_list]} { incr i 1 } {
                $this purge_single [lindex $new_list $i]
            }
            $this plot 1.0
            return 0
         } else {
            puts "FLAG ..."
            # normal verify - user is aked to purge wrong ref targets
            set wid .skycat1.d
            catch {destroy $wid}
            set w [InputDialog $wid \
                   -text $text \
                   -bitmap warning \
                   -modal 1 \
                   -buttons {OK Cancel}]

            set result [$w activate]
            set loc_list [split $result , ]

            # we first have to purge the highest order number
            set new_list [lsort -integer -decreasing $loc_list]
            for {set i 0} {$i < [llength $new_list]} { incr i 1 } {
                $this purge_single [lindex $new_list $i]
            }
            $this plot 1.0

            if {[string compare $result $t] || $num==0} {
               # if old==new (nothing edited) or no ref targ specified 
               info_dialog "Guide Star\nVerification Result:\n\n   Failed" .skycat1
               return 1
            } else {
               info_dialog "Guide Star\nVerification Result:\n\n     Ok" .skycat1
               return 0
            }
         }
      }
   }


#-----------------------------------------------------------------------
   ::itcl::body GUIDE_STAR::purge_single { j } {

      # puts stdout "$this: purge_single $j "
      if {$j<1 || $j>$num} {
         # puts stdout "$this purge_single: $j not in 1..$num"
      } else {
         for {set i $j} {$i < $num} {incr i 1} {
             set guid($i,a) $guid([expr $i+1],a)
             set guid($i,d) $guid([expr $i+1],d)
         }
         if {$num>0} { incr num -1 }
      }
      # puts stdout "new number of ref_targ : $num"
   }


#-----------------------------------------------------------------------
   ::itcl::body GUIDE_STAR::plot { radius } {

      # puts stdout "$this: plot"
      catch {$m_canvas delete GUIDESTAR }
      set radius2 [expr $radius * 0.95]
      set sadius  [expr $radius / 5.0 ]
      set sadius2 [expr $radius2 / 5.0 ]
      for {set i 1} {$i <= $num} { incr i 1} {
          $m_image convert coords $guid($i,a) $guid($i,d) "wcs $eqx" x y canvas
          $m_canvas create oval [expr $x-$radius] [expr $y-$radius] \
               [expr $x+$radius] [expr $y+$radius] -outline yellow -tag " GUIDESTAR guid$i "
          $m_canvas create oval [expr $x-$radius2] [expr $y-$radius2] \
               [expr $x+$radius2] [expr $y+$radius2] -outline black -tag " GUIDESTAR guid$i "
          $m_canvas create oval [expr $x-$sadius] [expr $y-$sadius] \
               [expr $x+$sadius] [expr $y+$sadius] -outline yellow -tag " GUIDESTAR guid$i "
          $m_canvas create oval [expr $x-$sadius2] [expr $y-$sadius2] \
               [expr $x+$sadius2] [expr $y+$sadius2] -outline black -tag " GUIDESTAR guid$i "
          $m_canvas create text $x $y -fill yellow -tag " GUIDESTAR guid$i " -anchor w -text [ format "  %2d" $i ]
          $m_canvas create text $x $y -fill black -tag " GUIDESTAR guid$i " -anchor e -text [ format "%2d  " $i ]
      }
   }


#-----------------------------------------------------------------------
   ::itcl::body GUIDE_STAR::reset { } {

      # puts stdout "$this: reset"
      for {set i 1} { $i <=10} { incr i 1} {
          set guid($i,a) 0.0
          set guid($i,d) 0.0
      }
      set num 0
      $this plot 1.0; # delete them all from the canvas
   }

#-----------------------------------------------------------------------
   ::itcl::body GUIDE_STAR::show { } {

      # puts stdout "$this: show"
      set text "Guide Stars\n\n\ "
      if {$num>0} {
         for {set i 1} {$i <=$num} { incr i 1} {
              append text [format "#%2d   %s   %s\n\ " $i $guid($i,a) $guid($i,d) ]
         }
      } else {
         append text "no stars selected\n\ "
      }
      info_dialog $text .skycat1
   }

#-----------------------------------------------------------------------
   ::itcl::body GUIDE_STAR::guid { } {

      # puts stdout "$this: guid $num"
      return $num }

#-----------------------------------------------------------------------
   ::itcl::body GUIDE_STAR::test { } {

      puts stdout [$this guid]
      $this show
      for {set i 1 } {$i<=11} {incr i 1} {
          $this put 00:00:30.3 -72:34:34.5
          $this show
          puts stdout [$this guid]
          puts stdout "[$this get $i a] [$this get $i d]"
      }
   }

#-----------------------------------------------------------------------
   ::itcl::body GUIDE_STAR::init_guide_star { } {

      GUIDE_STAR guide_star
      guide_star test
      guide_star show
      guide_star destructor
   }

}
# end of namespace
