itk::usual MOS {}

namespace eval mos {

   class StatusPanel {

   # Modified R.H. 2007 09 07
   # Modes removed, panel re-arranged for OSMOS

#---------------------------------------------------------------------
   constructor {args} {

      set w_ .statuspanel
      catch { eval configure $args } result
      puts "configure result: $result"
      create_pan
   }

#---------------------------------------------------------------------
   destructor { wm $w_ withdraw }

#---------------------------------------------------------------------
   public method update { } {

      set noms [$mos_class anoms]
      set PM [ldelete [split [mos::MOS_SLIT::get_MASK_NAID] " "] ""]

      #Instrument setup
      $w_.mos config -value [$mos_class cget -instrument]
      $w_.cam config -value [$mos_class cget -camera]
      $w_.grat config -value [$mos_class cget -grating]
      $w_.filt config -value [$mos_class cget -filter]

      #Mos slits
      $w_.m_typ config -value [$mos_class cget -mos_shape]
      $w_.sw   config -value [format "%5.2f" [$mos_class cget -slit_width] ]
      $w_.sl   config -value [$mos_class cget -slit_length]
      $w_.m_nos config -value $noms
      $w_.m_pid config -value [lindex $PM 0];              # maks label
      $w_.m_mid config -value [lindex $PM 1];              # mask id
      $w_.m_rsl config -value [$mos_class arsc]
#      $w_.m_tec config -value [mos::MOS_SLIT::get_mmff];  # technical mask

      if {[$mos_class cget -pics]} {
         $w_.pics config -value ON
      } else {
         $w_.pics config -value OFF
      }

      $w_.nort config -value [$mos_class info variable sp_nort  -value]
      $w_.guid config -value [$mos_class info variable sp_guid  -value]
      $w_.fits_i config -value [$mos_class info variable sp_instrume -value]
      $w_.fits_o config -value [$mos_class info variable sp_origin   -value]
      $w_.llfn config -value [$mos_class info variable last_load_fn -value]
      $w_.lsfn config -value [$mos_class info variable last_save_fn -value]
      $w_.lact config -value [$mos_class info variable last_action -value]

   }


#---------------------------------------------------------------------
   private method create_pan { } {

      mos::MOS::EXE begin
      puts "create_pan"
      TopLevelWidget $w_
      $w_ add_menubar
      set m [$w_ add_menubutton File]

      # index =  2
      $w_ add_menuitem $m command "Exit" \
          {Exit StatusPanel}  \
               -state normal  \
               -command "wm withdraw $w_"

      wm title $w_ "Status Panel"
      wm iconname $w_ "OMS Status"

      layout_dialog
      mos::MOS::EXE end

   }

#---------------------------------------------------------------------
   private method add_label_contents_a  {} {

      #   single pack
      #
      #  Label [Value]
      #
      #   lw     vw

      # double pack
      #
      # Label [Value]  Label [Value]
      #
      #  lws   vws      vws   vws

      set lw 12; set vw 17;
      set lws 8; set vws 5;

      pack [frame $w_.inst -borderwidth 2 -relief raised] -side top -fill x
      pack [frame $w_.border1 -borderwidth 2 -relief sunken] -side top -fill x
      pack [frame $w_.mos_keys -borderwidth 2 -relief raised] -side top -fill x
      pack [frame $w_.border2 -borderwidth 2 -relief sunken] -side top -fill x
      pack [frame $w_.keys -borderwidth 2 -relief raised] -side top -fill x

      # part 1 Instrument Setup
      pack [LabelWidget $w_.head1  \
                 -text "Instrument Setup"     \
                 -labelwidth 14  ]  \
                 -side top -expand 1 -pady 1 -padx 1 -in $w_.inst

      pack [LabelValue $w_.mos    \
                 -text "Instrument" \
                 -value "none"      \
                 -labelwidth $lw    \
                 -valuewidth $vw ]  \
                 -side top -expand 1 -pady 1 -padx 1 -in $w_.inst

# --------------------- hier pixel scale einfuegen ----------------------
      pack [LabelValue $w_.cam  \
                  -text "Camera" \
                  -value none \
                  -labelwidth $lw    \
                  -valuewidth $vw ]  \
                  -side top -expand 1 -pady 1 -padx 1 -in $w_.inst

      pack [LabelValue $w_.grat \
                -text "Grating" \
                -value none \
                -labelwidth $lw    \
                -valuewidth $vw ]  \
                -side top -expand 1 -pady 1 -padx 1 -in $w_.inst

      pack [LabelValue $w_.filt \
                -text "Filter" \
                -value none \
                -labelwidth $lw    \
                -valuewidth $vw ]  \
                -side top -expand 1 -pady 1 -padx 1 -in $w_.inst

      #  part 2 MOS keys
      pack [LabelWidget $w_.head3  \
                 -text "MOS Slits"    \
                 -labelwidth 10 ]  \
                 -side top -expand 1 -pady 1 -padx 1 -in $w_.mos_keys

      pack [LabelValue $w_.m_typ  \
                  -text "Slit Type" \
                  -value none       \
                  -labelwidth $lw    \
                  -valuewidth $vw ]  \
                  -side top -expand 1 -pady 1 -padx 1 -in $w_.mos_keys

      pack [LabelValue $w_.sw   \
                -text "Width/''" \
                -value 0 \
                -labelwidth $lw    \
                -valuewidth $vw ]  \
                -side top -expand 1 -pady 1 -padx 1 -in $w_.mos_keys

      pack [LabelValue $w_.sl   \
                -text "Length/''" \
                -value 0 \
                -labelwidth $lw    \
                -valuewidth $vw ]  \
                -side top -expand 1 -pady 1 -padx 1 -in $w_.mos_keys

      pack [LabelValue $w_.m_nos  \
                  -text "Slit Num"  \
                  -value none       \
                  -labelwidth $lw    \
                  -valuewidth $vw ]  \
                  -side top -expand 1 -pady 1 -padx 1 -in $w_.mos_keys

     pack [LabelValue $w_.m_pid  \
                  -text "Mask NA"  \
                  -value none       \
                  -labelwidth $lw    \
                  -valuewidth $vw ]  \
                  -side top -expand 1 -pady 1 -padx 1 -in $w_.mos_keys

      pack [LabelValue $w_.m_mid  \
                  -text "MASK ID"  \
                  -value none       \
                  -labelwidth $lw    \
                  -valuewidth $vw ]  \
                  -side top -expand 1 -pady 1 -padx 1 -in $w_.mos_keys

      pack [LabelValue $w_.m_rsl  \
                  -text "RefSlit"  \
                  -value none       \
                  -labelwidth $lw    \
                  -valuewidth $vw ]  \
                  -side top -expand 1 -pady 1 -padx 1 -in $w_.mos_keys

      # part 3 Session
      pack [LabelWidget $w_.head2  \
                 -text "Session"    \
                 -labelwidth 10 ]  \
                 -side top -expand 1 -pady 1 -padx 1 -in $w_.keys

      pack [LabelValue $w_.pics     \
                -text "Cen/Slit"    \
                -value ""           \
                -labelwidth $lw     \
                -valuewidth $vw  ]  \
                -side top -expand 1 -pady 1 -padx 1 -in $w_.keys

      pack [LabelValue $w_.nort     \
                -text "Ref Targs"   \
                -value ""           \
                -labelwidth $lw   \
                -valuewidth $vw ] \
                -side top -expand 1 -pady 1 -padx 1 -in $w_.keys

      pack [LabelValue $w_.guid     \
                -text "Guide Stars"   \
                -value ""           \
                -labelwidth $lw   \
                -valuewidth $vw ] \
                -side top -expand 1 -pady 1 -padx 1 -in $w_.keys

      pack [LabelValue $w_.fits_i   \
                -text "FITS ins"       \
                -value ""           \
                -labelwidth $lw   \
                -valuewidth $vw]  \
                -side top -expand 1 -pady 1 -padx 1 -in $w_.keys

      pack [LabelValue $w_.fits_o   \
                -text "FITS orig"      \
                -value ""           \
                -labelwidth $lw   \
                -valuewidth $vw ] \
                -side top -expand 1 -pady 1 -padx 1 -in $w_.keys

      pack [LabelValue $w_.fina   \
                -text "ProjName" \
                -value 0 \
                -labelwidth $lw    \
                -valuewidth $vw ]  \
                -side top -expand 1 -pady 1 -padx 1 -in $w_.keys

      pack [LabelValue $w_.lsfn   \
                -text "Last Save" \
                -value "" \
                -labelwidth $lw    \
                -valuewidth $vw ]  \
                -side top -expand 1 -pady 1 -padx 1 -in $w_.keys

      pack [LabelValue $w_.llfn   \
                -text "Last Load" \
                -value "" \
                -labelwidth $lw    \
                -valuewidth $vw ]  \
                -side top -expand 1 -pady 1 -padx 1 -in $w_.keys

      pack [LabelValue $w_.lact   \
                -text "Last Act" \
                -value "" \
                -labelwidth $lw    \
                -valuewidth $vw ]  \
                -side top -expand 1 -pady 1 -padx 1 -in $w_.keys

   }

#---------------------------------------------------------------------
   private method layout_dialog {} {

      add_dialog_buttons
      add_label_contents_a

   }

#---------------------------------------------------------------------
   private method add_dialog_buttons {} {

      # dialog buttons
      pack [frame $w_.buttons -borderwidth 2 -relief raised] -side bottom -fill x
      pack [button $w_.update \
                 -text "UpDate" \
                 -command [code $this update ]] \
                 -side left -expand 1 -pady 2m -in $w_.buttons
      pack [button $w_.ok \
                 -text "Icon" \
                 -command "wm iconify $w_" ] \
                 -side left -expand 1 -pady 2m -in $w_.buttons
      pack [button $w_.close \
                 -text "Close" \
                 -command "destroy $w_" ] \
                 -side left -expand 1 -pady 2m -in $w_.buttons
#      pack [button $w_.bell \
#                 -text "Bell" \
#                 -command bell ] \
#                 -side left -expand 1 -pady 2m -in $w_.buttons
   }

#---------------------------------------------------------------------
   private method ldelete { list value} {

      # taken from Welch, p34
      # delete one list element by value
      set ix [lsearch -exact $list $value]
      if {$ix>=0} {
         return [lreplace $list $ix $ix]
      } else {
          return $list
      }
   }

   public variable mos_class
   private variable w_

   }
}
